PublicBlumBlumShub Class Referenceabstract

BlumBlumShub without factorization of the modulus. More...

`#include <blumshub.h>`

Inheritance diagram for PublicBlumBlumShub:

## Public Member Functions

| PublicBlumBlumShub (const Integer &n, const Integer &seed)
unsigned int | GenerateBit ()
| generate new random bit and return it More...
byte | GenerateByte ()
| generate new random byte and return it
void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
void | ProcessData (byte *outString, const byte *inString, size_t length)
| encrypt or decrypt an array of bytes of specified length More...
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
virtual void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
virtual bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | DiscardBytes (size_t n)
| generate and discard n bytes
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
template<class IT >
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
StreamTransformation & | Ref ()
| return a reference to this object, useful for passing a temporary object to a function that takes a non-const reference
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data More...
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual bool | IsRandomAccess () const =0
| returns whether this cipher supports random access
virtual void | Seek (lword n)
| for random access ciphers, seek to an absolute position

## Protected Attributes

ModularArithmetic | modn
word | maxBits
word | bitsLeft
Integer | current

## Friends

class | BlumGoldwasserPublicKey
class | BlumGoldwasserPrivateKey

## Detailed Description

BlumBlumShub without factorization of the modulus.

Definition at line 12 of file blumshub.h.

## Member Function Documentation

unsigned int PublicBlumBlumShub::GenerateBit | ( |  | ) |

virtual

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented from RandomNumberGenerator.

void PublicBlumBlumShub::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual

encrypt or decrypt an array of bytes of specified length

Note
  either inString == outString, or they don't overlap

Implements StreamTransformation.

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const

inline virtual inherited

returns the input block size that is most efficient for this cipher

Note
  optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0

Reimplemented in ECB_OneWay.

Definition at line 480 of file cryptlib.h.

virtual void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual inherited

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented in CBC_CTS_Decryption, and CBC_CTS_Encryption.

The documentation for this class was generated from the following file:

- blumshub.h